--------------------------------------------------------
-- POPSY-X
--------------------------------------------------------
GoToSubMenuIcon(actualCat,actualOption,true)
XEBKeepInSubMenu=true

function POPSY_DrawItem(POPSY_TempX, POPSY_TempY, POPSY_TempFaded, POPSY_TempName, POPSY_TempIDDraw, POPSY_TempType) -- int, int, boolean, string, string
	if POPSY_TempIDDraw == "mechadrones" then
		POPSY_IconToDraw = 51;
	else
		POPSY_IconToDraw = 127;
	end
	if POPSY_TempType == "PS2SX_ID_Launch" then
		POPSY_TempAdd=" (PS2SX)"
	else
		POPSY_TempAdd=" (POPStarter)"
	end
	if POPSY_TempFaded then
		if POPSY_TempName ~= "" then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY, columnsFade)
			if POPSY_IconToDraw == 51 then
				Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, "PS2SX", baseColorFaded)
			else
				Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, xebLang[65]..POPSY_TempAdd, baseColorFaded)
			end
		end
		Font.ftPrint(fontBig, POPSY_TempX+69, plusYValue+POPSY_TempY+16, 0, 512, 64, POPSY_TempName, baseColorFaded)
	else
		if POPSY_TempName ~= "" then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY)
			if POPSY_IconToDraw == 51 then
				Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, "PS2SX", baseColorFull)
			else
				Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, xebLang[65]..POPSY_TempAdd, baseColorFull)
			end
		end
		Font.ftPrint(fontBig, POPSY_TempX+69, plusYValue+POPSY_TempY+16, 0, 512, 64, POPSY_TempName, baseColorFull)
	end
end

function POPSY_DrawItemFrame(POPSY_TempX, POPSY_TempY, POPSY_TempFaded, POPSY_TempName, POPSY_TempTheFrame, POPSY_TempTheColorA, POPSY_TempTheColorB, POPSY_TempIDDraw, POPSY_TempType) -- int, int, boolean/int, string, int, u32 color, u32 color, string
	if POPSY_TempIDDraw == "mechadrones" then
		POPSY_IconToDraw = 51;
	else
		POPSY_IconToDraw = 127;
	end
	if POPSY_TempType == "PS2SX_ID_Launch" then
		POPSY_TempAdd=" (PS2SX)"
	else
		POPSY_TempAdd=" (POPStarter)"
	end
	if POPSY_TempName ~= "" then
		if POPSY_TempFaded == true then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY, POPSY_SpriteGetAnimationAlphaMin(POPSY_TempTheFrame))
		elseif POPSY_TempFaded == false then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY, POPSY_SpriteGetAnimationAlphaMinMax(POPSY_TempTheFrame))
		elseif POPSY_TempFaded == 2 then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY, POPSY_SpriteGetAnimationAlphaMax(POPSY_TempTheFrame))
		elseif POPSY_TempFaded == 3 then
			Graphics.drawImage(themeInUse[POPSY_IconToDraw], POPSY_TempX, plusYValue+POPSY_TempY, POPSY_SpriteGetAnimationAlphaMaxFade(POPSY_TempTheFrame))
		end
		if POPSY_IconToDraw == 51 then
			Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, "PS2SX", POPSY_ColorGetAnimationAlpha(POPSY_TempTheFrame,POPSY_TempTheColorA,POPSY_TempTheColorB))
		else
			Font.ftPrint(fontSmall, POPSY_TempX+70, plusYValue+POPSY_TempY+32, 0, 512, 64, xebLang[65]..POPSY_TempAdd, POPSY_ColorGetAnimationAlpha(POPSY_TempTheFrame,POPSY_TempTheColorA,POPSY_TempTheColorB))
		end
	end
	Font.ftPrint(fontBig, POPSY_TempX+69, plusYValue+POPSY_TempY+16, 0, 512, 64, POPSY_TempName, POPSY_ColorGetAnimationAlpha(POPSY_TempTheFrame,POPSY_TempTheColorA,POPSY_TempTheColorB))
end

function POPSY_ColorGetAnimationAlpha(POPSY_TempFrame,POPSY_TempColorA,POPSY_TempColorB) -- int, u32 color, u32 color
	POPSY_TempColorAA=Color.getA(POPSY_TempColorA);
	POPSY_TempColorBA=Color.getA(POPSY_TempColorB);
	POPSY_TempColorAR=Color.getR(POPSY_TempColorA);
	POPSY_TempColorBR=Color.getR(POPSY_TempColorB);
	POPSY_TempColorAG=Color.getG(POPSY_TempColorA);
	POPSY_TempColorBG=Color.getG(POPSY_TempColorB);
	POPSY_TempColorAB=Color.getB(POPSY_TempColorA);
	POPSY_TempColorBB=Color.getB(POPSY_TempColorB);
	POPSY_TempAlphaC=POPSY_TempColorAA-POPSY_TempColorBA;
	POPSY_TempAlphaC=POPSY_TempAlphaC/4;
	POPSY_TempAlphaC=POPSY_TempFrame*POPSY_TempAlphaC;
	POPSY_TempAlphaC=POPSY_TempColorBA+POPSY_TempAlphaC
	POPSY_TempNextColorA=XEBMathRound(POPSY_TempAlphaC);
	POPSY_TempAlphaC=POPSY_TempColorAR-POPSY_TempColorBR;
	POPSY_TempAlphaC=POPSY_TempAlphaC/4;
	POPSY_TempAlphaC=POPSY_TempFrame*POPSY_TempAlphaC;
	POPSY_TempAlphaC=POPSY_TempColorBR+POPSY_TempAlphaC
	POPSY_TempNextColorR=XEBMathRound(POPSY_TempAlphaC);
	POPSY_TempAlphaC=POPSY_TempColorAG-POPSY_TempColorBG;
	POPSY_TempAlphaC=POPSY_TempAlphaC/4;
	POPSY_TempAlphaC=POPSY_TempFrame*POPSY_TempAlphaC;
	POPSY_TempAlphaC=POPSY_TempColorBG+POPSY_TempAlphaC
	POPSY_TempNextColorG=XEBMathRound(POPSY_TempAlphaC);
	POPSY_TempAlphaC=POPSY_TempColorAB-POPSY_TempColorBB;
	POPSY_TempAlphaC=POPSY_TempAlphaC/4;
	POPSY_TempAlphaC=POPSY_TempFrame*POPSY_TempAlphaC;
	POPSY_TempAlphaC=POPSY_TempColorBB+POPSY_TempAlphaC
	POPSY_TempNextColorB=XEBMathRound(POPSY_TempAlphaC);
	POPSY_TempNewColor=Color.new(POPSY_TempNextColorR,POPSY_TempNextColorG,POPSY_TempNextColorB,POPSY_TempNextColorA);
	return POPSY_TempNewColor;
end

function POPSY_SpriteGetAnimationAlphaMin(POPSY_TempFrame)
	POPSY_TempAlpha=columnsFade;
	POPSY_TempAlpha=POPSY_TempAlpha/4;
	POPSY_TempAlpha=POPSY_TempFrame*POPSY_TempAlpha;
	POPSY_TempAlpha=XEBMathRound(POPSY_TempAlpha);
	return POPSY_TempAlpha;
end

function POPSY_SpriteGetAnimationAlphaMax(POPSY_TempFrame)
	POPSY_TempAlpha=255;
	POPSY_TempAlpha=POPSY_TempAlpha-columnsFade
	POPSY_TempAlpha=POPSY_TempAlpha/4;
	POPSY_TempAlpha=POPSY_TempFrame*POPSY_TempAlpha;
	POPSY_TempAlpha=columnsFade+POPSY_TempAlpha
	POPSY_TempAlpha=XEBMathRound(POPSY_TempAlpha);
	return POPSY_TempAlpha;
end

function POPSY_SpriteGetAnimationAlphaMaxFade(POPSY_TempFrame)
	POPSY_TempAlpha=columnsFade;
	POPSY_TempAlpha=POPSY_TempAlpha-255
	POPSY_TempAlpha=POPSY_TempAlpha/4;
	POPSY_TempAlpha=POPSY_TempFrame*POPSY_TempAlpha;
	POPSY_TempAlpha=255+POPSY_TempAlpha
	POPSY_TempAlpha=XEBMathRound(POPSY_TempAlpha);
	return POPSY_TempAlpha;
end

function POPSY_SpriteGetAnimationAlphaMinMax(POPSY_TempFrame)
	if POPSY_TempFrame == 4 then
		POPSY_TempAlpha=255;
	else
		POPSY_TempAlpha=POPSY_TempFrame*64
	end
	return POPSY_TempAlpha;
end

POPSY_ColorFullZero=Color.new(Color.getR(baseColorFull),Color.getG(baseColorFull),Color.getB(baseColorFull),0)
POPSY_ColorFadedZero=Color.new(Color.getR(baseColorFaded),Color.getG(baseColorFaded),Color.getB(baseColorFaded),0)

POPSY_PS2SXLocationPrefix="mass:/HWC-PSX/"
POPSY_POPSAPPLocation="mass:/conf_apps.cfg"

POPSY_ErrorMessage=xebLang[37]
POPSY_ErrorMessage = POPSY_ErrorMessage:gsub("PS2SX", "PS2SX / POPStarter (Apps)")

POPSY_PS2SX_IsThereAnError = false

function POPSY_ReadGameName(POPSY_TempConfPath) -- string
	POPSY_TempCfgTitle = "??????????"
	POPSY_TempNewTitle = "??????????"
	for POPSY_TempLine in io.lines(POPSY_TempConfPath) do
		if string.sub(POPSY_TempLine,1,7) == "NOMBRE=" then
			POPSY_TempCfgTitle = POPSY_TempLine;
		end
	end
	if POPSY_TempCfgTitle ~= "??????????" then
		POPSY_TempNewTitle=string.sub(POPSY_TempCfgTitle,8,string.len(POPSY_TempCfgTitle))
	end
	return POPSY_TempNewTitle;
end

POPSY_HasPS2SXMC=false

if System.doesFileExist(POPSY_PS2SXLocationPrefix.."mechadrones.apo") then
	POPSY_HasPS2SXMC=true
end

POPSY_GamesTotal = 0

POPSY_Games = {};

if System.doesDirectoryExist(POPSY_PS2SXLocationPrefix) then
	if System.doesFileExist(POPSY_PS2SXLocationPrefix.."usable.ps2sx") and System.doesFileExist(POPSY_PS2SXLocationPrefix.."turbineld.psx") then
		POPSY_ListDirectory = System.listDirectory(POPSY_PS2SXLocationPrefix.."conf/")
		for POPSY_i = 1, #POPSY_ListDirectory do
			if not POPSY_ListDirectory[POPSY_i].directory and string.sub(POPSY_ListDirectory[POPSY_i].name,string.len(POPSY_ListDirectory[POPSY_i].name)-8,string.len(POPSY_ListDirectory[POPSY_i].name)) == ".PS2SXCFG" then
				POPSY_TempNewName = POPSY_ReadGameName(POPSY_PS2SXLocationPrefix.."conf/"..POPSY_ListDirectory[POPSY_i].name)
				if POPSY_TempNewName ~= "??????????" then
					POPSY_GamesTotal = POPSY_GamesTotal+1
					POPSY_Games[POPSY_GamesTotal] = {};
					POPSY_Games[POPSY_GamesTotal].Name = POPSY_TempNewName;
					POPSY_Games[POPSY_GamesTotal].ID = string.sub(POPSY_ListDirectory[POPSY_i].name,1,string.len(POPSY_ListDirectory[POPSY_i].name)-9);
					POPSY_Games[POPSY_GamesTotal].Type = "PS2SX_ID_Launch";
				end
			end
		end
	else
		POPSY_PS2SX_IsThereAnError = true
	end
else
	POPSY_PS2SX_IsThereAnError = true
end

function POPSY_POPSAPP_split(POPSY_POPSAPP_splitinputstr, POPSY_POPSAPP_splitsep)
	if POPSY_POPSAPP_splitsep == nil then
		POPSY_POPSAPP_splitsep = "%s"
	end
	POPSY_POPSAPP_split_t=nil
	POPSY_POPSAPP_split_t={}
	for POPSY_POPSAPP_splitstr in string.gmatch(POPSY_POPSAPP_splitinputstr, "([^"..POPSY_POPSAPP_splitsep.."]+)") do
		table.insert(POPSY_POPSAPP_split_t, POPSY_POPSAPP_splitstr)
	end
	return POPSY_POPSAPP_split_t;
end

POPSY_POPSAPP_IsThereAnError = false

if System.doesFileExist(POPSY_POPSAPPLocation) then
	for POPSY_POPSAPP_TempLine in io.lines(POPSY_POPSAPPLocation) do
		if string.len(POPSY_POPSAPP_TempLine) > 5 then
			POPSY_POPSAPP_NewTable=nil
			POPSY_POPSAPP_NewTable=POPSY_POPSAPP_split(POPSY_POPSAPP_TempLine, "=")
			if string.sub(POPSY_POPSAPP_NewTable[2],1,14) == "mass:/POPS/XX." then
				POPSY_GamesTotal = POPSY_GamesTotal+1
				POPSY_Games[POPSY_GamesTotal] = {};
				POPSY_Games[POPSY_GamesTotal].Name = POPSY_POPSAPP_NewTable[1];
				POPSY_Games[POPSY_GamesTotal].ID = POPSY_POPSAPP_NewTable[2];
				POPSY_Games[POPSY_GamesTotal].Type = "Direct_ELF";
			end
		end
	end
else
	POPSY_POPSAPP_IsThereAnError = true
end

POPSY_ShowError=false

if POPSY_POPSAPP_IsThereAnError and POPSY_PS2SX_IsThereAnError and not POPSY_HasPS2SXMC then
	POPSY_ShowError=true
end

if not POPSY_ShowError then
	table.sort(POPSY_Games, function (POPSY_TempTabA, POPSY_TempTabB) return POPSY_TempTabA.Name < POPSY_TempTabB.Name end)
	
	for POPSY_i = -7, 0 do
		POPSY_Games[POPSY_i] = {};
		POPSY_Games[POPSY_i].Name = "";
		POPSY_Games[POPSY_i].ID = "";
	end
	
	for POPSY_i = POPSY_GamesTotal+1, POPSY_GamesTotal+7 do
		POPSY_Games[POPSY_i] = {};
		POPSY_Games[POPSY_i].Name = "";
		POPSY_Games[POPSY_i].ID = "";
	end
	
	POPSY_SelectedItem=1
end

if POPSY_HasPS2SXMC then
	POPSY_GamesTotal = POPSY_GamesTotal+1
	POPSY_Games[POPSY_GamesTotal] = {};
	POPSY_Games[POPSY_GamesTotal].Name = "Memory Cards";
	POPSY_Games[POPSY_GamesTotal].ID = "mechadrones";
	POPSY_Games[POPSY_GamesTotal].Type = "PS2SX_ID_Launch";
end

if POPSY_GamesTotal == 0 then
	POPSY_ShowError=true
end

for POPSY_i = 1, 3 do
	pad = Pads.get()
	Screen.clear()
	if backgroundFilter then
		Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
	else
		Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
	end
	thmDrawBKG()
	DrawSubMenu(actualCat,actualOption,true)
	
	if POPSY_ShowError then
		Font.ftPrint(fontBig, 152, plusYValue+222, 0, 512, 64, xebLang[35], POPSY_ColorGetAnimationAlpha(POPSY_i,baseColorFull,POPSY_ColorFullZero))
		Font.ftPrint(fontSmall, 153, plusYValue+238, 0, 512, 64, POPSY_ErrorMessage, POPSY_ColorGetAnimationAlpha(POPSY_i,baseColorFull,POPSY_ColorFullZero))
	else
		POPSY_ItemPosition = -5
		for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
			POPSY_iB_Y = POPSY_ItemPosition*71
			if POPSY_iB == POPSY_SelectedItem then
				POPSY_DrawItemFrame(152, 206, false, POPSY_Games[POPSY_iB].Name, POPSY_i, baseColorFull, POPSY_ColorFullZero, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			else
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135, true, POPSY_Games[POPSY_iB].Name, POPSY_i, baseColorFaded, POPSY_ColorFadedZero, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			end
			POPSY_ItemPosition=POPSY_ItemPosition+1
		end
	end
	spinDisc()
	thmDrawBKGOL()
	Screen.waitVblankStart()
	oldpad = pad;
	Screen.flip()
end

POPSY_HoldingUp=99
POPSY_HoldingUpDash=0
POPSY_HoldingDown=99
POPSY_HoldingDownDash=0

function POPSY_AnimateUp()
	spinDisc()
	thmDrawBKGOL()
	Screen.waitVblankStart()
	oldpad = pad;
	Screen.flip()
	for POPSY_Move = 1, 3 do
		pad = Pads.get()
		Screen.clear()
		if backgroundFilter then
			Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
		else
			Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
		end
		thmDrawBKG()
		DrawSubMenu(actualCat,actualOption,true)
		POPSY_PositionUp = XEBMathRound(POPSY_Move * 17.75)
		POPSY_ItemPosition = -5
		for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
			POPSY_iB_Y = POPSY_ItemPosition*71
			if POPSY_iB == POPSY_SelectedItem then
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135+POPSY_PositionUp, 3, POPSY_Games[POPSY_iB].Name, POPSY_Move, baseColorFaded, baseColorFull, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			elseif POPSY_iB == POPSY_SelectedItem-1 then
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135+POPSY_PositionUp, 2, POPSY_Games[POPSY_iB].Name, POPSY_Move, baseColorFull, baseColorFaded, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			else
				POPSY_DrawItem(152, POPSY_iB_Y+135+POPSY_PositionUp, true, POPSY_Games[POPSY_iB].Name, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			end
			POPSY_ItemPosition=POPSY_ItemPosition+1
			
		end
		if not Pads.check(pad, PAD_UP) then
			POPSY_HoldingUp=99
			POPSY_HoldingUpDash=0
		end
		if POPSY_Move ~= 3 then
			spinDisc()
			thmDrawBKGOL()
			Screen.waitVblankStart()
			oldpad = pad;
			Screen.flip()
		end
	end
end

function POPSY_AnimateDown()
	spinDisc()
	thmDrawBKGOL()
	Screen.waitVblankStart()
	oldpad = pad;
	Screen.flip()
	for POPSY_Move = 1, 3 do
		pad = Pads.get()
		Screen.clear()
		if backgroundFilter then
			Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
		else
			Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
		end
		thmDrawBKG()
		DrawSubMenu(actualCat,actualOption,true)
		POPSY_PositionDown = XEBMathRound(POPSY_Move * 17.75)
		POPSY_ItemPosition = -5
		for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
			POPSY_iB_Y = POPSY_ItemPosition*71
			if POPSY_iB == POPSY_SelectedItem then
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135-POPSY_PositionDown, 2, POPSY_Games[POPSY_iB].Name, POPSY_Move, baseColorFaded, baseColorFull, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			elseif POPSY_iB == POPSY_SelectedItem+1 then
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135-POPSY_PositionDown, 3, POPSY_Games[POPSY_iB].Name, POPSY_Move, baseColorFull, baseColorFaded, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			else
				POPSY_DrawItem(152, POPSY_iB_Y+135-POPSY_PositionDown, true, POPSY_Games[POPSY_iB].Name, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			end
			POPSY_ItemPosition=POPSY_ItemPosition+1
			
		end
		if not Pads.check(oldpad, PAD_DOWN) then
			POPSY_HoldingDown=99
			POPSY_HoldingDownDash=0
		end
		if not Pads.check(pad, PAD_DOWN) then
			POPSY_HoldingDown=99
			POPSY_HoldingDownDash=0
		end
		if POPSY_Move ~= 3 then
			spinDisc()
			thmDrawBKGOL()
			Screen.waitVblankStart()
			oldpad = pad;
			Screen.flip()
		end
	end
end

while XEBKeepInSubMenu do
	pad = Pads.get()
	Screen.clear()
	if backgroundFilter then
		Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
	else
		Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
	end
	thmDrawBKG()
	DrawSubMenu(actualCat,actualOption,true)
	
	if POPSY_ShowError then
		Font.ftPrint(fontBig, 152, plusYValue+222, 0, 512, 64, xebLang[35], baseColorFull)
		Font.ftPrint(fontSmall, 153, plusYValue+238, 0, 512, 64, POPSY_ErrorMessage, baseColorFull)
	else
		POPSY_ItemPosition = -5
		for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
			POPSY_iB_Y = POPSY_ItemPosition*71
			if POPSY_iB == POPSY_SelectedItem then
				POPSY_DrawItem(152, 206, false, POPSY_Games[POPSY_iB].Name, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			else
				POPSY_DrawItem(152, POPSY_iB_Y+135, true, POPSY_Games[POPSY_iB].Name, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			end
			POPSY_ItemPosition=POPSY_ItemPosition+1
		end
		if Pads.check(pad, PAD_ACCEPT) and not Pads.check(oldpad, PAD_ACCEPT) then
			for POPSY_WaveByeBye = 1, 25 do
				Screen.clear()
				if backgroundFilter then
					Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
				else
					Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
				end
				thmDrawBKG()
				DrawSubMenu(actualCat,actualOption,true)
				POPSY_ItemPosition = -5
				for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
					POPSY_iB_Y = POPSY_ItemPosition*71
					if POPSY_iB ~= POPSY_SelectedItem then
						POPSY_DrawItem(152, POPSY_iB_Y+135, true, POPSY_Games[POPSY_iB].Name, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
					end
					POPSY_ItemPosition=POPSY_ItemPosition+1
				end
				spinDisc()
				thmDrawBKGOL()
				Graphics.drawRect(352, 240, 704, 480, Color.new(0,0,0,POPSY_WaveByeBye*10))
				POPSY_DrawItem(152, 206, false, POPSY_Games[POPSY_SelectedItem].Name, POPSY_Games[POPSY_SelectedItem].ID, POPSY_Games[POPSY_SelectedItem].Type)
				Screen.waitVblankStart()
				Screen.flip()
			end
			for POPSY_WaveByeBye = 1, 25 do
				Screen.clear()
				POPSY_DrawItem(152, 206, false, POPSY_Games[POPSY_SelectedItem].Name, POPSY_Games[POPSY_SelectedItem].ID, POPSY_Games[POPSY_SelectedItem].Type)
				Graphics.drawRect(352, 240, 704, 480, Color.new(0,0,0,POPSY_WaveByeBye*10))
				Screen.waitVblankStart()
				Screen.flip()
			end
			if POPSY_Games[POPSY_SelectedItem].Type == "PS2SX_ID_Launch" then
				LaunchELF(POPSY_PS2SXLocationPrefix..POPSY_Games[POPSY_SelectedItem].ID..".apo", 0, "Default", false, 1)
			else
				LaunchELF(POPSY_Games[POPSY_SelectedItem].ID, 0, "Default", false, 1)
			end
		elseif Pads.check(pad, PAD_UP) then
			if not Pads.check(oldpad, PAD_UP) then
				if POPSY_SelectedItem ~= 1 then
					POPSY_HoldingUp=1;
					POPSY_HoldingUpDash=POPSY_HoldingUpDash+1;
					POPSY_AnimateUp()
					POPSY_SelectedItem = POPSY_SelectedItem - 1
				end
			elseif POPSY_HoldingUp==17 and Pads.check(oldpad, PAD_UP) then
				if POPSY_SelectedItem ~= 1 then
					POPSY_HoldingUp=1;
					POPSY_HoldingUpDash=POPSY_HoldingUpDash+1;
					POPSY_AnimateUp()
					POPSY_SelectedItem = POPSY_SelectedItem - 1
				end
			elseif POPSY_HoldingUpDash>1 and Pads.check(oldpad, PAD_UP) then
				if POPSY_SelectedItem ~= 1 then
					POPSY_HoldingUp=1;
					POPSY_HoldingUpDash=POPSY_HoldingUpDash+1;
					POPSY_AnimateUp()
					POPSY_SelectedItem = POPSY_SelectedItem - 1
				end
			end
			POPSY_HoldingUp=POPSY_HoldingUp+1;
		elseif Pads.check(pad, PAD_DOWN) then
			if not Pads.check(oldpad, PAD_DOWN) then
				if POPSY_SelectedItem ~= POPSY_GamesTotal then
					POPSY_HoldingDown=1;
					POPSY_HoldingDownDash=POPSY_HoldingDownDash+1;
					POPSY_AnimateDown()
					POPSY_SelectedItem = POPSY_SelectedItem + 1
				end
			elseif POPSY_HoldingDown==17 and Pads.check(oldpad, PAD_DOWN) then
				if POPSY_SelectedItem ~= POPSY_GamesTotal then
					POPSY_HoldingUp=1;
					POPSY_HoldingDownDash=POPSY_HoldingDownDash+1;
					POPSY_AnimateDown()
					POPSY_SelectedItem = POPSY_SelectedItem + 1
				end
			elseif POPSY_HoldingDownDash>1 and Pads.check(oldpad, PAD_DOWN) then
				if POPSY_SelectedItem ~= POPSY_GamesTotal then
					POPSY_HoldingDown=1;
					POPSY_HoldingDownDash=POPSY_HoldingDownDash+1;
					POPSY_AnimateDown()
					POPSY_SelectedItem = POPSY_SelectedItem + 1
				end
			end
			POPSY_HoldingDown=POPSY_HoldingDown+1;
		elseif Pads.check(pad, PAD_LEFT) and not Pads.check(oldpad, PAD_LEFT) then
			XEBKeepInSubMenu=false
		end
		if not Pads.check(pad, PAD_UP) then
			POPSY_HoldingUp=99
			POPSY_HoldingUpDash=0
		end
		if not Pads.check(pad, PAD_DOWN) then
			POPSY_HoldingDown=99
			POPSY_HoldingDownDash=0
		end
	end
	if Pads.check(pad, PAD_CANCEL) and not Pads.check(oldpad, PAD_CANCEL) then
		XEBKeepInSubMenu=false
	end
	spinDisc()
	thmDrawBKGOL()
	Screen.waitVblankStart()
	oldpad = pad;
	Screen.flip()
end

for POPSY_i = 1, 3 do
	pad = Pads.get()
	Screen.clear()
	if backgroundFilter then
		Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
	else
		Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
	end
	thmDrawBKG()
	DrawSubMenu(actualCat,actualOption,true)
	POPSY_ReverseFrame=4-POPSY_i
	if POPSY_ShowError then
		Font.ftPrint(fontBig, 152, plusYValue+222, 0, 512, 64, xebLang[35], POPSY_ColorGetAnimationAlpha(POPSY_ReverseFrame,baseColorFull,POPSY_ColorFullZero))
		Font.ftPrint(fontSmall, 153, plusYValue+238, 0, 512, 64, POPSY_ErrorMessage, POPSY_ColorGetAnimationAlpha(POPSY_ReverseFrame,baseColorFull,POPSY_ColorFullZero))
	else
		POPSY_ItemPosition = -5
		for POPSY_iB = POPSY_SelectedItem-6, POPSY_SelectedItem+5 do
			POPSY_iB_Y = POPSY_ItemPosition*71
			if POPSY_iB == POPSY_SelectedItem then
				POPSY_DrawItemFrame(152, 206, false, POPSY_Games[POPSY_iB].Name, POPSY_ReverseFrame, baseColorFull, POPSY_ColorFullZero, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			else
				POPSY_DrawItemFrame(152, POPSY_iB_Y+135, true, POPSY_Games[POPSY_iB].Name, POPSY_ReverseFrame, baseColorFaded, POPSY_ColorFadedZero, POPSY_Games[POPSY_iB].ID, POPSY_Games[POPSY_iB].Type)
			end
			POPSY_ItemPosition=POPSY_ItemPosition+1
		end
	end
	spinDisc()
	thmDrawBKGOL()
	Screen.waitVblankStart()
	oldpad = pad;
	Screen.flip()
end

BackFromSubMenuIcon(actualCat,actualOption,true)
pad = Pads.get()
Screen.clear()
if backgroundFilter then
	Graphics.drawImageExtended(themeInUse[-1], 352, plusYValue+240, 0, 0, backgroundValueX, backgroundValueY, 704, 480, 0, 255)
else
	Graphics.drawImage(themeInUse[-1], 0, plusYValue+0)
end
thmDrawBKG()
DrawInterface(actualCat,actualOption,true)
spinDisc()
thmDrawBKGOL()
oldpad = pad;
--------------------------------------------------------
-- POPSY-X
--------------------------------------------------------